Subject: Re: [NAT] draft-kuniaki-nats-00.txt

From: Kuniaki Kondo <[email-masked]>
Date: Mon, 2 Jul 2001 13:16:48 +0900

Hello,

"Brian E Carpenter <[email-masked]>" (Fri, 29 Jun 2001 09:30:23 -0500) 
wrote:

> Kuniaki,
> 
> A proposal to use an IPv4 option as an address extension was discussed
> in an IETF BOF in 1994 (Seattle). It did not consider NATs as such
> because they were very little used then (oh, happy days!). However it
> was rejected, really for three reasons
> 1) it is in practice impossible to deploy any new IPv4 option
> 2) the host changes required looked very expensive
> 3) it was felt strategically better to proceed with IPng
> 
> You can find the meeting minutes etc at 
> http://www.ietf.cnri.reston.va.us/proceedings/94mar/ipng/aeiou.html
> 
> draft-carpenter-aeiou-00.txt is a little harder to find :-)

This is very interesting draft.
However, My draft expects to use at boarder between global area and
private area. It means that this NATS box will be instead of SOHO 
router. And, Backbone routers don't care for NATS packets.

My draft don't expect to hold down consumption of IPv4 address usage.
My purpose is that a host placed at private network can connect to other
host placed at private network.
Therefore, I can consider another way for realizing this purpose.
However, using option header is very easy to implementation.

Actually, I already implement a test version of NATS Phase 1(not Phase 2)
for host side. In this implementation, I wrote a few hundreds of codes
for NATS library, and wrote some line of codes for patch of telnet command,
And it worked.

> 
> Anyway, I don't think the basic arguments have changed in 7 years. 
> 
> Regards
>    Brian Carpenter
> 
> Kuniaki Kondo wrote:
> > 
> > Folks,
> > 
> > I applied new draft that is draft-kuniaki-nats-00.txt, few weeks ago.
> > http://www.ietf.org/internet-drafts/draft-kuniaki-nats-00.txt
> > 
> > In this draft, I proposed to enhance NAT.
> > This enhanced NAT can be access from a host placed at global area
> > to a host placed behind NAT by using Sub-Address.
> > 
> > If you have some commnets, please tell me it.
> > 
> > Thank you.
> > 
> > --
> > Kuniaki Kondo
> > [email-masked]
> 
> _______________________________________________
> nat mailing list
> [email-masked]
> http://www.ietf.org/mailman/listinfo/nat

--
Kuniaki Kondo
[email-masked]

---

From: Pyda Srisuresh <[email-masked]>
Date: Sun, 8 Jul 2001 18:37:49 -0700 (PDT)

> router. And, Backbone routers don't care for NATS packets.

Kuniaki - I agree with the concerns expressed by Brian. Even as Core
routers donot care, IP options do slow down forwarding performance of
the core routers. So, use of IP options is proabbly not a good idea
to use across the Internet.

Also, I am a little confused about whether or not NATS changed the 
source IP address of a packet originatig from private domain. 
I believe, Section 6.2 (Second bullet from the last) says that 
NATS does change the source IP address. If so, how is this different
from NAT? If this was a typo and the source IP address is not changed,
how is a response sent back to the original host?

The DNS resolve and other mechanisms also seem pretty involved.
Do you expect IANA to dole out private subnet IDs (in the range of
1 to 64K)? Lots of coordination required - when the world is making
an effort to transition to IPv6.

> host placed at private network.

Agreed. At best, the mechanism will work when connecting two branches
of a private enterprise. But, it will have lots of difficulty connecting
to Internet nodes and enterprises that do not support NATS (which is a lot).
It will also have difficulty working with other private enterprises.

> However, using option header is very easy to implementation.
I believe, any mechanism that requires coordination with large
number of IP nodes across realms or with IANA and other Internet
services is not a good idea to pursue at this time. IPv6 is the
solution we have chosen to go with.

> for NATS library, and wrote some line of codes for patch of telnet command,

That is yet another poblem. You have to change end-host applications 
(ex: telnet command, as you point out) and IP protocol stacks to support
the new NATS scheme. That is quite a bit of an effort and for what? Just
to retain IPv4 and private addresses - why not use IPv6? 

> > Anyway, I don't think the basic arguments have changed in 7 years. 

regards, 
suresh

__________________________________________________
Do You Yahoo!?
Get personalized email addresses from Yahoo! Mail
http://personal.mail.yahoo.com/

---

From: Kuniaki Kondo <[email-masked]>
Date: Tue, 10 Jul 2001 17:23:10 +0900

Hello, Pyda.

"Pyda Srisuresh <[email-masked]>" (Sun, 8 Jul 2001 18:37:49 -0700 (PDT)) 

> to use across the Internet.

  I see. If a packet has IP options, then IP Current backbone routers
  processes it using software switch. However, This matter how number
  of packets are processed by backbone router, I believe. 

> how is a response sent back to the original host?

  NATS changes the source IP address.
  In this situation, why we need sub-addresses, I write a document
  at http://www.bugest.net/nats/nats_slide/What_is_the_NATS.files/frame.htm

> an effort to transition to IPv6.

  In my proposal, sub-address is not managed by anybody.
  I expect that sub-address should be managed by operator of private
  network. Therefore, I don't expect IANA to dole out sub-address.

  About DNS, My proposal uses HINFO for sub-address.

> to retain IPv4 and private addresses - why not use IPv6? 

  I think that all aprication should not support NATS.
  Normally, we sould use normal IPv4 packet.　However, It is true what
  the hosts sould support the new NATS scheme.

  Why not use IPv6?
  - Because IPv6 can not use in consumer area.
    However, End-users need a end-to-end solution, especially home user.
    Recently, end-users connect to the Internet using full-time connection,
    such as xDSL. And, 1 family has many PCs, and it's connected by full-time
    connection.
    In this situation, end-users have to use the NAPT at border between
    the Internet and home network. If so, those PC which is connected on 
    home network can not be accessed from the Internet or another NAT/NAPT
    networks.

--
Kuniaki Kondo
[email-masked]

---

From: Brian E Carpenter <[email-masked]>
Date: Tue, 10 Jul 2001 09:54:26 -0500

Kuniaki Kondo wrote:
...
>   - Because IPv6 can not use in consumer area.

What on earth do you mean? IPv6 exists for most consumer operating systems,
which NATS certainly does not.

  Brian

---

From: Kuniaki Kondo <[email-masked]>
Date: Wed, 11 Jul 2001 10:35:37 +0900

Hello, Brain,

"Brian E Carpenter <[email-masked]>" (Tue, 10 Jul 2001 09:54:26 -0500) 

> which NATS certainly does not.

  Certainly, each OSes work IPv6. However, IPv6 backbone network does not
  ready. and, IPv6 still have some problems.
  In this situation, IPv6 work in experimental network, but end-users can
  not use IPv6 yet.

--
Kuniaki Kondo
[email-masked]